' Lawson Labs, Inc.                     Model 201 24-Bit Delta-Sigma Converter
' 15 Phoenixville Pike                  Polled Mode Demonstration Code
' Kalispell, MT  59901
' 800 321-5355 or 610 725-8800                        October 30, 1995  Rev D

  COMMND$ = "C=Chan  E=Ext code  S=System cal  Esc=end" + SPACE$(32)
  CLS : ON ERROR GOTO READERR: OPEN "DRIVR201.CFG" FOR INPUT AS #2
  INPUT #2, MODEREGHI%, MODEREGMID%, MODEREGLO%, CHANNEL%, FILTER%, AVERAGE%
  INPUT #2, EXTCCODE%, BAUD%, COM$, INPBUF%, NUMAVG, BU%, GAIN%, RATE, WL%
  CLOSE : ON ERROR GOTO 0
  IF WL% = 0 THEN WORDCNT% = 2 ELSE WORDCNT% = 3
  MODEREGHI% = MODEREGHI% AND &HFE 'clear powerdown bit
  OPEN COM$ + "300,N,8,1,BIN,RS,CS,DS,CD,RB" FOR RANDOM AS #1
  CLS : LOCATE 10, 30: PRINT "Signing on": OUTBYTE% = &H0: WAKEUPCALLS = 0
  ON ERROR GOTO 1000
WAKEUP:           'send master reset token to Model 201 to begin sign-on
  WAKEUPCALLS = WAKEUPCALLS + 1
  IF WAKEUPCALLS = 40 THEN PRINT "can't wake": END
  OUT$ = CHR$(OUTBYTE%): PRINT #1, OUT$; : XX = .2: GOSUB WAITXX
EMPTYBUFFER:      'initialize buffer
  IF LOC(1) <> 0 THEN GOSUB GETCHAR: GOTO EMPTYBUFFER
  IF INPBYTE% <> 3 THEN GOTO WAKEUP ELSE XX = .2: GOSUB WAITXX
  OUT$ = CHR$(&H88): PRINT #1, OUT$; : XX = .1: GOSUB WAITXX 'sign-on token
  OUT$ = CHR$(BAUD%): PRINT #1, OUT$;      'send new baud rate
  WAITIME = 1: NUMCHARS% = 1: GOSUB WAITCHAR: GOSUB GETCHAR
  IF INPBYTE% <> BAUD% THEN GOTO WAKEUP    'if baud not echoed then try again
  CLOSE : BAUDRT% = 9600 / 2 ^ BAUD%    'set baud rate from file
  S$ = COM$ + STR$(BAUDRT%) + ",N,8,1,BIN,RS,CS,DS,CD,RB"
  OPEN S$ FOR RANDOM AS #1       'reopen COM port at new baud
  XX = .1: GOSUB WAITXX                 'wait .1 sec for power supply
  OUT$ = CHR$(&H0): PRINT #1, OUT$; : ON ERROR GOTO 0  'send end-echo command
  GOSUB SETMODE  'send A/D registers
  OUTB1% = AVERAGE%: OUTB2% = FILTER%: GOSUB SENDPACKET  'send avg. and filt.
  OUTB2% = 1: GOSUB SENDPACKET 'set 1 for polled mode
  GOSUB READMODE: GOSUB SETCCODE  'verify A/D mode registers and set channel
  WAITIME = (NUMAVG / RATE) + BAUD% / 10 + 2  'calculate conversion wait time
  GOSUB SYSCAL      'calibrate before displaying data
POLLOOP:            'get conversions, scale to volts and display
  IF A$ <> "" THEN A$ = "": LOCATE 25, 8: PRINT COMMND$
  GOSUB GETCONV
  PRINT USING "     ##,###,###"; COUNT#; : PRINT USING "     ##.######"; VOLTS;
  PRINT "     Chan="; CHANNEL%; "   Ext="; EXTCCODE%
  A$ = UCASE$(INKEY$): IF A$ <> "" THEN LOCATE 25, 1: PRINT SPACE$(80);
  IF A$ = "C" THEN GOSUB CHANNELCODE
  IF A$ = "E" THEN GOSUB EXTCCODE
  IF A$ = "S" THEN GOSUB SYSCAL
  IF A$ = CHR$(27) THEN CLOSE : END ELSE GOTO POLLOOP

EXTCCODE: 'select external control code for output A, B, C, and D
  LOCATE 25, 22: INPUT "Enter External control code"; EXTCCODE%
  IF EXTCCODE% < 0 OR EXTCCODE% > 15 THEN GOTO EXTCCODE ELSE GOTO SETCCODE
CHANNELCODE: 'select A/D analog input channel
  LOCATE 25, 36: INPUT "Enter Channel"; CHANNEL%
  IF CHANNEL% < 0 OR CHANNEL% > 7 THEN GOTO CHANNELCODE
SETCCODE: 'set up bytes for transmission to Model 201
  OUTB1% = &H1: OUTB2% = (CHANNEL% * 16) + EXTCCODE%
SENDPACKET: 'send command, argument & checksum
  OUT$ = CHR$(OUTB1%): PRINT #1, OUT$; : OUT$ = CHR$(OUTB2%): PRINT #1, OUT$;
  CHKSUM% = ((OUTB1% + OUTB2%) AND 255): OUT$ = CHR$(CHKSUM%): PRINT #1, OUT$; :
RETURN
GETCHAR:    'fetch one byte from serial buffer
  INPBYTE% = 0
  IF LOC(1) <> 0 THEN OUT$ = INPUT$(1, #1): INPBYTE% = (ASC(OUT$) AND &HFF)
RETURN
GETCONV:    'get an A/D conversion, calculate count and scale in volts
  OUTB1% = &H81: GOSUB SENDPACKET  'send read conversion command
  NUMCHARS% = WORDCNT% + 1: GOSUB WAITCHAR: GOSUB GETCHAR    'get result
  GOSUB GETCHAR: BYTE1# = INPBYTE%: GOSUB GETCHAR: BYTE2# = INPBYTE%
  IF WORDCNT% = 3 THEN GOSUB GETCHAR: BYTE3# = INPBYTE% ELSE BYTE3# = 0
  COUNT# = BYTE1# + BYTE2# * 256 + BYTE3# * 65536  'convert bytes to count
  VOLTS = (COUNT# * .0000002980232#)
  IF WORDCNT% = 2 THEN VOLTS = VOLTS * 256  '16-bit mode
  IF BU% = 0 THEN VOLTS = VOLTS * 2 - 5  'bipolar mode
RETURN
SYSCAL:    'perform system calibration
  IF GAIN% <> 1 THEN   'check for gain not equal to 1 before calibration
    ORGAIN% = GAIN%: GAIN% = 0: GOSUB WARMSTART: GAIN% = ORGAIN%
  END IF  'if gain not equal to 1, save original gain and calibrate with 1
  ORGCHAN% = CHANNEL%: CHANNEL% = 7: A$ = "O": GOSUB DOCAL 'offset cal.
  CHANNEL% = 6: A$ = "F": GOSUB DOCAL                      'full-scale cal.
  IF GAIN% <> 1 THEN GOSUB WARMSTART: CHANNEL% = 7: A$ = "O": GOSUB DOCAL
  CHANNEL% = ORGCHAN%: GOSUB SETCCODE 'restore original channel
  XX = 4 / RATE: GOSUB WAITXX         'wait for A/D to settle
RETURN
DOCAL:     'perform individual calibration on channel selected
  OUTB2% = (CHANNEL% * 16) + EXTCCODE%
  ORGW = WAITIME: WAITIME = WAITIME + FTIME + 2
  IF A$ = "O" THEN OUTB1% = &H82: LOCATE 25, 27: PRINT "Offset Calibration    ";
  IF A$ = "F" THEN OUTB1% = &H83: LOCATE 25, 27: PRINT "Full-scale Calibration";
  GOSUB SENDPACKET: NUMCHARS% = WORDCNT% + 1: GOSUB WAITCHAR
  FOR I = 1 TO WORDCNT% + 1: GOSUB GETCHAR: NEXT: WAITIME = ORGW
RETURN
SETMODE:  'send mode registers to Model 201
  OUTB1% = MODEREGHI%: OUTB2% = MODEREGMID%: GOSUB SENDPACKET
  OUTB1% = MODEREGLO%: GOSUB SENDPACKET
RETURN
WAITCHAR:  'wait xx seconds for NUMCHARS% characters
  IF TIMER + WAITIME > 86399 THEN GOTO WAITCHAR ELSE XX = TIMER + WAITIME
HOLDON:
  IF LOC(1) >= NUMCHARS% THEN RETURN
  IF TIMER < XX THEN GOTO HOLDON ELSE PRINT " Serial port time-out": END
RETURN
WAITXX:  'wait xx seconds
  IF TIMER + XX > 86399 THEN GOTO WAITXX ELSE XX = TIMER + XX
WAITLOOP:
  IF TIMER < XX THEN GOTO WAITLOOP
RETURN
WARMSTART:  're-start after mode change
  OUTB1% = &H84: GOSUB SENDPACKET: XX = .1: GOSUB WAITXX: GOSUB SETMODE
  NUMCHARS% = 1: GOSUB WAITCHAR: GOSUB GETCHAR
READMODE:   'verify mode registers were properly read
  NUMCHARS% = 3: GOSUB WAITCHAR
  GOSUB GETCHAR: IF (INPBYTE% AND &H1F) <> (MODEREGHI% AND &H1F) THEN BEEP
  GOSUB GETCHAR: IF INPBYTE% <> MODEREGMID% THEN BEEP
  GOSUB GETCHAR: IF INPBYTE% <> MODEREGLO% THEN BEEP
RETURN
1000
  CLOSE #1
  OPEN COM$ + "300,N,8,1,BIN,RS,CS,DS,CD,RB" FOR RANDOM AS #1
  RESUME NEXT    'ignore serial errors during sign-on
READERR:
  CLS : PRINT "Unable to read DRIVR201.CFG file": END

